"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var tcomb_1 = __importDefault(require("tcomb"));
var specificString = function (str) { return tcomb_1.default.refinement(tcomb_1.default.String, function (s) { return s === str; }); };
var ParallelDirs = specificString('ParallelDirs');
var SameDir = specificString('SameDir');
var SubDir = specificString('SubDir');
var TestStructure = tcomb_1.default.union([ParallelDirs, SameDir, SubDir]);
exports.Config = tcomb_1.default.struct({
    packagePath: tcomb_1.default.String,
    pkgJson: tcomb_1.default.Object,
    projectRoot: tcomb_1.default.String,
    sourcePath: tcomb_1.default.String,
    testPath: tcomb_1.default.String,
    testStructure: TestStructure,
    testSuffix: tcomb_1.default.String,
}, 'Config');
exports.Paths = tcomb_1.default.struct({
    packagePath: tcomb_1.default.String,
    projectRoot: tcomb_1.default.String,
    sourcePath: tcomb_1.default.String,
    srcInsideProject: tcomb_1.default.String,
    testInsideProject: tcomb_1.default.String,
    testPath: tcomb_1.default.String,
}, 'Paths');
exports.ComponentGeneration = tcomb_1.default.struct({
    ast: tcomb_1.default.Array,
    changesToCaller: tcomb_1.default.Array,
    componentName: tcomb_1.default.String,
    content: tcomb_1.default.String,
}, 'ComponentGeneration');
//# sourceMappingURL=tcomb.js.map